﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinTree;


namespace UltraTreeSample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraTree1.Override.LabelEdit = Infragistics.Win.DefaultableBoolean.True;
            ClassNeedingUpperCase cnuc = new ClassNeedingUpperCase();
            
            for (int i = 1; i < 16; i++)
            {
                ultraTree1.Nodes.Add("Key" + i.ToString(), "Noooooooooooooooooooode " + i.ToString());
            }

            foreach (UltraTreeNode nudo in ultraTree1.Nodes)
            {
                if (nudo.Index % 2 == 0)
                {
                    nudo.Tag = cnuc;
                }
            }

            for (int i = 1; i < 16; i++)
            {
                treeView1.Nodes.Add("Key" + i.ToString(), "Noooooooooooooooooooooode " + i.ToString());
            }
            treeView1.ShowNodeToolTips = true;
        }

        private void ultraTree1_ControlAdded(object sender, ControlEventArgs e)
        {
            if (ultraTree1.SelectedNodes.Count == 1)
            {
                UltraTreeNode node = ultraTree1.SelectedNodes[0];

                TextBox textBox = ultraTree1.Controls[0] as TextBox;
                if (node.Tag is ClassNeedingUpperCase)
                {
                    
                    if (textBox != null)
                    {
                        textBox.CharacterCasing = CharacterCasing.Upper;
                    }
                }
                else
                {
                    if (textBox != null)
                    {
                        textBox.CharacterCasing = CharacterCasing.Normal;
                    }
                }
            }
        }

        private void ultraTree1_BeforeLabelEdit(object sender, CancelableNodeEventArgs e)
        {
            UltraTree control = sender as UltraTree;
            control.ControlAdded -= new ControlEventHandler(control_ControlAdded);
            control.ControlAdded += new ControlEventHandler(control_ControlAdded);

            ultraTree1.ControlAdded += new ControlEventHandler(ultraTree1_ControlAdded);

        }

        private void ultraTree1_ControlRemoved(object sender, ControlEventArgs e)
        {
            ultraTree1.ControlAdded -= new ControlEventHandler(ultraTree1_ControlAdded);
        }

        void control_ControlAdded(object sender, ControlEventArgs e)
        {
            TextBox textBox = e.Control as TextBox;
            UltraTree tree = textBox != null ? textBox.Parent as UltraTree : null;
            UltraTreeNode activeNode = tree != null ? tree.ActiveNode : null;

            if (activeNode != null)
            {
                //  TODO: Check activeNode.Tag for character case criteria
                if (activeNode.Tag is ClassNeedingUpperCase)
                {
                    textBox.CharacterCasing = CharacterCasing.Upper;
                }
            }

            //  Unhook from the event
            tree.ControlAdded -= new ControlEventHandler(control_ControlAdded);
        }

        private void ultraTree1_AfterLabelEdit(object sender, NodeEventArgs e)
        {
            ultraTree1.Controls.Remove(ultraTree1.Controls[0]);
            
        }

        private void removeLastNodeButton_Click(object sender, EventArgs e)
        {
            UltraTreeNode lastParentNode = this.ultraTree1.Nodes[this.ultraTree1.Nodes.Count - 1];
            //UltraTreeNode lastChildNode = lastParentNode.Nodes[lastParentNode.Nodes.Count - 1];
            //lastChildNode.Remove();
            //lastParentNode.Remove();
            ultraTree1.Nodes.Remove(lastParentNode);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            TreeNode lastNode = treeView1.Nodes[treeView1.Nodes.Count - 1];
            lastNode.Remove();

        }


    }

    public class ClassNeedingUpperCase
    { }
}
